Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | |
| 3 | # OE-Core Build Environment Setup Script |
| 4 | # |
| 5 | # Copyright (C) 2006-2011 Linux Foundation |
| 6 | # |
Brad Bishop | c342db3 | 2019-05-15 21:57:59 -0400 | [diff] [blame] | 7 | # SPDX-License-Identifier: GPL-2.0-or-later |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 8 | # |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 9 | |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 10 | if ! $(return >/dev/null 2>&1) ; then |
| 11 | echo 'oe-buildenv-internal: error: this script must be sourced' |
| 12 | echo '' |
| 13 | echo 'Usage: . $OEROOT/scripts/oe-buildenv-internal &&' |
| 14 | echo '' |
| 15 | echo 'OpenEmbedded oe-buildenv-internal - an internal script that is' |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 16 | echo 'used in oe-init-build-env to initialize oe build environment' |
Brad Bishop | 6e60e8b | 2018-02-01 10:27:11 -0500 | [diff] [blame] | 17 | echo '' |
| 18 | exit 2 |
| 19 | fi |
| 20 | |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 21 | # It is assumed OEROOT is already defined when this is called |
| 22 | if [ -z "$OEROOT" ]; then |
| 23 | echo >&2 "Error: OEROOT is not defined!" |
| 24 | return 1 |
| 25 | fi |
| 26 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 27 | if [ -z "$OE_SKIP_SDK_CHECK" ] && [ -n "$OECORE_SDK_VERSION" ]; then |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 28 | echo >&2 "Error: The OE SDK/ADT was detected as already being present in this shell environment. Please use a clean shell when sourcing this environment script." |
| 29 | return 1 |
| 30 | fi |
| 31 | |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 32 | # We potentially have code that doesn't parse correctly with older versions |
| 33 | # of Python, and rather than fixing that and being eternally vigilant for |
| 34 | # any other new feature use, just check the version here. |
Andrew Geissler | 82c905d | 2020-04-13 13:39:40 -0500 | [diff] [blame] | 35 | py_v35_check=$(python3 -c 'import sys; print(sys.version_info >= (3,5,0))') |
| 36 | if [ "$py_v35_check" != "True" ]; then |
| 37 | echo >&2 "BitBake requires Python 3.5.0 or later as 'python3 (scripts/install-buildtools can be used if needed)'" |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 38 | return 1 |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 39 | fi |
Andrew Geissler | 82c905d | 2020-04-13 13:39:40 -0500 | [diff] [blame] | 40 | unset py_v35_check |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 41 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 42 | if [ -z "$BDIR" ]; then |
| 43 | if [ -z "$1" ]; then |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 44 | BDIR="build" |
| 45 | else |
| 46 | BDIR="$1" |
| 47 | if [ "$BDIR" = "/" ]; then |
| 48 | echo >&2 "Error: / is not supported as a build directory." |
| 49 | return 1 |
| 50 | fi |
| 51 | |
| 52 | # Remove any possible trailing slashes. This is used to work around |
| 53 | # buggy readlink in Ubuntu 10.04 that doesn't ignore trailing slashes |
| 54 | # and hence "readlink -f new_dir_to_be_created/" returns empty. |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 55 | BDIR=$(echo $BDIR | sed -re 's|/+$||') |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 56 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 57 | BDIR=$(readlink -f "$BDIR") |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 58 | if [ -z "$BDIR" ]; then |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 59 | PARENTDIR=$(dirname "$1") |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 60 | echo >&2 "Error: the directory $PARENTDIR does not exist?" |
| 61 | return 1 |
| 62 | fi |
| 63 | fi |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 64 | if [ -n "$2" ]; then |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 65 | BITBAKEDIR="$2" |
| 66 | fi |
| 67 | fi |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 68 | if [ "${BDIR#/}" != "$BDIR" ]; then |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 69 | BUILDDIR="$BDIR" |
| 70 | else |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 71 | BUILDDIR="$(pwd)/$BDIR" |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 72 | fi |
| 73 | unset BDIR |
| 74 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 75 | if [ -z "$BITBAKEDIR" ]; then |
| 76 | BITBAKEDIR="$OEROOT/bitbake$BBEXTRA" |
Brad Bishop | 316dfdd | 2018-06-25 12:45:53 -0400 | [diff] [blame] | 77 | test -d "$BITBAKEDIR" || BITBAKEDIR="$OEROOT/../bitbake$BBEXTRA" |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 78 | fi |
| 79 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 80 | BITBAKEDIR=$(readlink -f "$BITBAKEDIR") |
| 81 | BUILDDIR=$(readlink -f "$BUILDDIR") |
Brad Bishop | d7bf8c1 | 2018-02-25 22:55:05 -0500 | [diff] [blame] | 82 | BBPATH=$BUILDDIR |
| 83 | |
| 84 | export BBPATH |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 85 | |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 86 | if [ ! -d "$BITBAKEDIR" ]; then |
Patrick Williams | c0f7c04 | 2017-02-23 20:41:17 -0600 | [diff] [blame] | 87 | echo >&2 "Error: The bitbake directory ($BITBAKEDIR) does not exist! Please ensure a copy of bitbake exists at this location or specify an alternative path on the command line" |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 88 | return 1 |
| 89 | fi |
| 90 | |
| 91 | # Make sure our paths are at the beginning of $PATH |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 92 | for newpath in "$BITBAKEDIR/bin" "$OEROOT/scripts"; do |
| 93 | # Remove any existences of $newpath from $PATH |
| 94 | PATH=$(echo $PATH | sed -re "s#(^|:)$newpath(:|$)#\2#g;s#^:##") |
| 95 | |
| 96 | # Add $newpath to $PATH |
| 97 | PATH="$newpath:$PATH" |
| 98 | done |
| 99 | unset BITBAKEDIR newpath |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 100 | |
| 101 | # Used by the runqemu script |
| 102 | export BUILDDIR |
| 103 | export PATH |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 104 | |
| 105 | BB_ENV_EXTRAWHITE_OE="MACHINE DISTRO TCMODE TCLIBC HTTP_PROXY http_proxy \ |
Patrick Williams | c124f4f | 2015-09-15 14:41:29 -0500 | [diff] [blame] | 106 | HTTPS_PROXY https_proxy FTP_PROXY ftp_proxy FTPS_PROXY ftps_proxy ALL_PROXY \ |
| 107 | all_proxy NO_PROXY no_proxy SSH_AGENT_PID SSH_AUTH_SOCK BB_SRCREV_POLICY \ |
| 108 | SDKMACHINE BB_NUMBER_THREADS BB_NO_NETWORK PARALLEL_MAKE GIT_PROXY_COMMAND \ |
Andrew Geissler | 82c905d | 2020-04-13 13:39:40 -0500 | [diff] [blame] | 109 | SOCKS5_PASSWD SOCKS5_USER SCREENDIR STAMPS_DIR BBPATH_EXTRA BB_SETSCENE_ENFORCE \ |
| 110 | BB_LOGCONFIG" |
Patrick Williams | d8c66bc | 2016-06-20 12:57:21 -0500 | [diff] [blame] | 111 | |
| 112 | BB_ENV_EXTRAWHITE="$(echo $BB_ENV_EXTRAWHITE $BB_ENV_EXTRAWHITE_OE | tr ' ' '\n' | LC_ALL=C sort --unique | tr '\n' ' ')" |
| 113 | |
| 114 | export BB_ENV_EXTRAWHITE |